﻿@page
@using Canyon.Backend.Web.Services;
@using Canyon.GM.Panel.Services.Core;
@using Microsoft.AspNetCore.Mvc.Localization;
@inject IStringLocalizer StringLocalizer;
@inject IHtmlLocalizer HtmlLocalizer;
@model Canyon.GM.Panel.Areas.Realm.Pages.ListModel
@{
    ViewData[TITLE] = StringLocalizer.GetString("RealmManageTitle");
}

<div class="mb-2">
    <a class="btn btn-primary" asp-area="Realm" asp-page="/Index" asp-route-RealmID="@Guid.Empty">
        <i class="fa-solid fa-plus" aria-hidden="true"></i>
        @StringLocalizer["NewRealm"]
    </a>
</div>
<div class="table-responsive">
    <div class="alert alert-warning" role="alert">
        <h4 class="alert-heading">@StringLocalizer["TemporaryRealmActionNotificationTitle"]</h4>
        @HtmlLocalizer["HtmlTemporaryRealmActionNotificationContent"]
    </div>
    @await Html.PartialAsync("_ErrorSummary")
    <table class="table table-hover">
        <caption>
            @StringLocalizer["RealmList"]
        </caption>
        <thead>
            <tr>
                <th scope="col">@StringLocalizer["RealmID"]</th>
                <th scope="col">@StringLocalizer["RealmName"]</th>
                <th scope="col">@StringLocalizer["Action"]</th>
                <th scope="col">&nbsp;</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var realm in Model.Realms)
            {
                <tr>
                    <td>@realm.Data.RealmID</td>
                    <td>@realm.Data.RealmName</td>                    
                    <td>
                        @if (realm.Status != Sockets.Piglet.PigletActor.RealmState.Offline)
                        {
                            <form method="post" asp-page-handler="AnnounceMaintenance" class="AnnounceMaintenanceFrm"><input type="hidden" asp-for="Input.RealmID" value="@realm.Data.RealmID" /><button class="btn btn-link" type="submit" data-bs-toggle="tooltip" data-bs-title="@StringLocalizer["AnnounceMaintenance"]"><i aria-hidden="true" class="fa fa-screwdriver-wrench"></i> @StringLocalizer["Maintenance"]</button></form>
                            <form method="post" asp-page-handler="StopServer" class="StopServerFrm"><input type="hidden" asp-for="Input.RealmID" value="@realm.Data.RealmID" /><button class="btn btn-link" type="submit" data-bs-toggle="tooltip" data-bs-title="@StringLocalizer["StopServer"]"><i aria-hidden="true" class="fa fa-power-off"></i> @StringLocalizer["Close"]</button></form>
                        }
                        else
                        {
                            <form method="post" asp-page-handler="StartServer" class="StartServerFrm"><input type="hidden" asp-for="Input.RealmID" value="@realm.Data.RealmID" /><button class="btn btn-link" type="submit" data-bs-toggle="tooltip" data-bs-title="@StringLocalizer["StartServer"]"><i aria-hidden="true" class="fa fa-play"></i> @StringLocalizer["Start"]</button></form>
                        }
                    </td>
                    <td>
                        <a class="btn btn-link" asp-area="Realm" asp-page="/Index" asp-route-RealmID="@realm.Data.RealmID">
                            <i aria-hidden="true" class="fa fa-search"></i>
                        </a>
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>

@section Scripts
{
    <script>
        const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]');
        const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl));

        $('.StartServerFrm').submit(function (e) {
            e.preventDefault();
            const $this = $(this);
            ModalAlert({
                type: 'confirm',
                headerText: '@StringLocalizer["RealmAction"]',
                messageText: '@StringLocalizer["StartServerConfirmation"]',
                alertType: 'info',
                yesButtonText: '@StringLocalizer["Yes"]',
                noButtonText: '@StringLocalizer["No"]'
            }).done(function (confirmResult) {
                if (confirmResult === true) {
                    $this.unbind('submit').submit();
                }
            });
        });

        $('.AnnounceMaintenanceFrm').submit(function (e) {
            e.preventDefault();
            const $this = $(this);
            ModalAlert({
                type: 'confirm',
                headerText: '@StringLocalizer["RealmAction"]',
                messageText: '@StringLocalizer["AnnounceMaintenanceConfirmation"]',
                alertType: 'info',
                yesButtonText: '@StringLocalizer["Yes"]',
                noButtonText: '@StringLocalizer["No"]'
            }).done(function (confirmResult) {
                if (confirmResult === true) {
                    $this.unbind('submit').submit();
                }
            });
        });

        $('.StopServerFrm').submit(function (e) {
            e.preventDefault();
            const $this = $(this);
            ModalAlert({
                type: 'confirm',
                headerText: '@StringLocalizer["RealmAction"]',
                messageText: '@StringLocalizer["StopServerConfirmation"]',
                alertType: 'info',
                yesButtonText: '@StringLocalizer["Yes"]',
                noButtonText: '@StringLocalizer["No"]'
            }).done(function (confirmResult) {
                if (confirmResult === true) {
                    $this.unbind('submit').submit();
                }
            });
        });

    </script>
}